import pygame
import sys
import numpy as np
import copy
import pickle

N_st = 5       #   刺激の総数

pygame.init()
desk_w, desk_h = pygame.display.get_desktop_sizes()[0]
print(desk_w, ',  ', desk_h)

my_font = pygame.font.SysFont(None,int(desk_h/30))    

rng = np.random.default_rng()

screen = pygame.display.set_mode((desk_w, desk_h))  #    Full screen
"""
         教示（msg_intro.png）の表示
"""
msg_img = pygame.image.load('msg_intro.png')
msg_w, msg_h = msg_img.get_size()
print(msg_w, ',  ', msg_h)
screen.fill((255,255,255))
screen.blit(msg_img, ((desk_w - msg_w)//2, (desk_h - msg_h)//2))
pygame.display.flip()
"""
          Enterキーが押されるまで表示
"""
ck = True
while ck:
    for e in pygame.event.get():
        if e.type == pygame.QUIT:
            pygame.quit()
            sys.exit()
        elif e.type == pygame.KEYDOWN:
            if e.key == pygame.K_ESCAPE:     #   Escapeキーを押すと強制終了
                pygame.quit()
                sys.exit()
            elif e.key == pygame.K_RETURN:    #   Enter key pressed?
                ck = False
                break

screen.fill((0,0,0))  

scl_img = int(desk_h / 5)          #   パッチサイズ

"""
      N_st=5 に対して作成
　　　大きさの異なる５枚の円盤のイメージをリストL_patchesに格納
"""
L_patches = []
for ip in range(5):
    temp_s = pygame.Surface((scl_img, scl_img))
    c_r = scl_img*0.5*0.2 + 0.8 * scl_img * 0.5 * ip/4
    pygame.draw.circle(temp_s, (255,255,255), (scl_img/2, scl_img/2), c_r)
    L_patches.append(temp_s)
                       

n_trials = 400    #    総試行数
L_res = []        #    提示刺激組と反応のリスト
i_trial = 0       #    試行数
for i_trial in range(n_trials):
    """
            N_st個の刺激から提示刺激として４個を選ぶ
    """
    st_choice = rng.choice(np.arange(N_st)+1, size=4, replace=False)
    st0 = st_choice[:2]        #     上に提示する対
    st1 = st_choice[2:]        #     下に提示する対

    screen.fill((0,0,0))  
    
    srfc_str = my_font.render(
        f'Difference Scaling: {i_trial+1}/{n_trials}', True, (255,255,255)) 
    str_w, str_h = srfc_str.get_size()
    screen.blit(srfc_str, ((desk_w - str_w)//2, 5))
    pygame.display.flip()
    """
           スペースキーの押下を待つ
    """
    ck = True
    while ck:
        for e in pygame.event.get():
            if e.type == pygame.QUIT:
                pygame.quit()
                sys.exit()
            elif e.type == pygame.KEYDOWN:
                if e.key == pygame.K_ESCAPE:
                    pygame.quit()
                    sys.exit()
            elif e.type == pygame.KEYUP:
                if e.key == pygame.K_SPACE:
                    ck = False
                    break
    """
             刺激組の提示
    """
    screen.blit(L_patches[st0[0]-1],
                (int(desk_w/2 - scl_img*1.2), int(scl_img)))
    screen.blit(L_patches[st0[1]-1],
                (int(desk_w/2 + scl_img*0.2), int(scl_img)))
    screen.blit(L_patches[st1[0]-1],
                (int(desk_w/2 - scl_img*1.2), int(3*scl_img)))
    screen.blit(L_patches[st1[1]-1], (int(desk_w/2 + scl_img*0.2), int(3*scl_img)))
    pygame.display.flip()

    X = None
    ck = True   
    while ck:
        for e in pygame.event.get():
            #print('e =',e)
            if e.type == pygame.QUIT:
                pygame.quit()
                sys.exit()
            elif e.type == pygame.KEYDOWN:
                if e.key == pygame.K_ESCAPE:
                    pygame.quit()
                    sys.exit()
                elif e.key == pygame.K_UP:
                    X = 1                      #    上の対が選ばれた
                    screen.fill((0,0,0)) 
                    pygame.display.flip()
                    ck = False
                    break
                elif e.key == pygame.K_DOWN:
                    X = 0                      #    下の対が選ばれた
                    screen.fill((0,0,0))  
                    pygame.display.flip()
                    ck = False
                    break
            if ck == False:
               break
    L_res.append([[st0,st1],X])       #   提示刺激の組と反応の記録
            
pygame.quit()

print(L_res)

fout_csv_nm = input('Output file name (*.csv) = ')
with open(fout_csv_nm, 'w') as f:
    f.write(',i,j,s,t,X\n')
    for i,v in enumerate(L_res):
        print(i, v)
        f.write(f'{i+1},{v[0][0][0]},{v[0][0][1]},' +
                f'{v[0][1][0]},{v[0][1][1]},{v[1]}\n')
        
print('\n' + fout_csv_nm + ' was saved.\n')
